package ca;

import java.io.File;

import javax.swing.JFrame;

import ca.gui.RuleEditor;
import ca.gui.Visualizer;

public class Main extends JFrame
{
	private static final long serialVersionUID = 7024589379489190278L;

    /**
     * Create the frame.
     */
    public Main()
    {
    	if( System.getProperty("org.lwjgl.librarypath") == null ){
    		
    		String[] path = {
    				System.getProperty("user.dir") + File.separator + "drivers" + File.separator + "native" + File.separator + getOS(),
    				System.getProperty("user.dir") + File.separator + "bin" + File.separator + "drivers" + File.separator + "native" + File.separator + getOS(),
    				System.getProperty("user.dir") + File.separator + "src" + File.separator + "drivers" + File.separator + "native" + File.separator + getOS()
    		};
    		
    		for(int i = 0; i<path.length; i++){
    			System.out.println(path[i]);
	    		if(new File(path[i]).exists()){
	    			System.setProperty("org.lwjgl.librarypath", path[i]);
	    		}
    		}
    	}
        
    	Visualizer visualizer = new Visualizer(6, 1+4*8, 6);
    	new RuleEditor(visualizer);
    	
    	visualizer.VSyncEnabled = true;
    	visualizer.fullScreen = false;
    	visualizer.displayWidth = 1024;
    	visualizer.displayHeight = 800;
    	visualizer.window_title = "CA Tester";
    	visualizer.run();  // will call init(), render(), mouse functions
    	
    }

    /**
     * Launch the application.
     */
    public static void main(String[] args)
    {
        new Main();
    }
    
    public String getOS(){
    	String os = System.getProperty("os.name").toLowerCase();
    	
		// windows
		if(os.indexOf("win") >= 0){
			return "windows";
		}
 
		// Mac
		if(os.indexOf("mac") >= 0){
			return "macosx";
		}
 
		// linux or unix
		if(os.indexOf("nix") >= 0 || os.indexOf("nux") >= 0){
			return "linux";
		}
 
		// Solaris
		if(os.indexOf("sunos") >= 0){
			return "solaris";
		}
    	
    	return "windows";
    }
    
}

