package ca;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Util {

	public static void writeToFile(String filename, String data){
		PrintWriter out = null;
		try {
			out = new PrintWriter(new FileWriter(filename));
			
			out.print(data);
			
		} catch (IOException e) {
			System.err.println("Could not save "+filename);
		} finally {
	      if (out != null) {
	    	  System.out.println("Write to "+filename);
	          out.close();
	        } else {
	          System.out.println("PrintWriter not open");
	        }
		}
	}
	
	public static String readStringFromFile(String filename){
		FileReader input;
		String line, output = "";
		try {
			input = new FileReader(filename);
			BufferedReader bufRead = new BufferedReader(input);
			
			line = bufRead.readLine();
			
			if (line != null){
				output = line;
			}
			
			//System.out.println("Loaded "+filename);
		} catch (FileNotFoundException e) {
			System.err.println("Could not find "+filename);
		} catch (IOException e) {
			System.err.println("Could not read "+filename);
		}
		
		return output;
	}
	
	
}
