package ca.gui;

import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.AbstractListModel;

import ca.rules.HashRule;

public class HashRuleListModel extends AbstractListModel {
	
	private static final long serialVersionUID = 1L;
	private ArrayList<HashRule> rules;
	
	public HashRuleListModel(){
		rules = new ArrayList<HashRule>();
		
	}

	@Override
	public Object getElementAt(int index) {
		return rules.get(index);
	}

	@Override
	public int getSize() {
		return rules.size();
	}
	
	public void add(HashRule hr){
		rules.add(hr);
	}

	public void importRules(HashMap<String, HashRule> hashRules) {
		for(HashRule hr : hashRules.values()){
			add(hr);
		}
	}

}
