package ca.gui;

import glapp.GLApp;

import java.io.File;
import java.util.HashMap;

public class StateTextureArrayList extends HashMap<Integer, Integer> {

	private static final long serialVersionUID = -3872706150643434477L;
	
	private static int missingTexture = 0;

	public StateTextureArrayList() {
		super();
		reloadTextures();
	}
	
	private void reloadTextures() {
		File dir = new File("resources/images/state/");
    	String[] fileList = dir.list();
    	
    	String fileNotFound = "resources/images/state/missing.png";
    	missingTexture = GLApp.makeTexture(fileNotFound);
    	
    	for(String file : fileList){
    		try {
	    		int number = Integer.parseInt(file.substring(0, file.length()-4));
	    		put(number, GLApp.makeTexture("resources/images/state/"+file));
    		} catch (NumberFormatException e) {
				// not a number, don't care
			}
    	}
	}
	
	@Override
	public Integer get(Object key) {
		Integer object = null;
		try {
			object = super.get(key);
		} catch (IndexOutOfBoundsException e) {
			object = missingTexture;
		}
		return object;
	}
	
}
