package ca.rules;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class HashRule extends Rule {
	
	private String neighbourhood;
	private Pattern pattern;
	
	public HashRule(String neighbourhood, int nextState, String description) {
		super(nextState, description);
		this.neighbourhood = neighbourhood;
		
		String replaced = neighbourhood.replace("x", "\\d+");
		pattern = Pattern.compile(replaced);
	}

	@Override
	public boolean checkCell(String hashFromCell) {

		Matcher matcher = pattern.matcher(hashFromCell);
		return matcher.matches();
		
	}
	
	public String getNeighbourhood(){
		return neighbourhood;
	}
	
	@Override
	public String toString() {
		return "HashRule: "+getDescription();
	}
	
	public static boolean isInteger( char c )  
	{  
	   try  
	   {  
	      Integer.parseInt( c + "" );  
	      return true;  
	   }  
	   catch( NumberFormatException e )  
	   {  
	      return false;  
	   }  
	}  
	
	public void setNeighbourhood(String neighbourhood){
		this.neighbourhood = neighbourhood;
	}

}
