package genetic;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

import mechanics.Game;
import ca.Cell;
import ca.CellStructures;
import ca.RuleBook;

public class BetterGeneticAlgorithm {
	
	private Game game;
	private HashMap<String, Integer> possibleRules;
	private int[] legalStates = {3, 4, 10, 11};
	
	public BetterGeneticAlgorithm() {
		game = new Game(null, CellStructures.BUILDNING_START, new RuleBook(null));
		game.goForwardToGeneration(58);
		
		possibleRules = new HashMap<String, Integer>();
		for(Cell c : game.getCellsInSubGrid()){
			
			if(possibleRules.containsKey(c.getHash())){
				int count = possibleRules.get(c.getHash());
				count++;
				possibleRules.put(c.getHash(), count);
			} else {
				possibleRules.put(c.getHash(), 1);
			}
		}
		try {

			FileWriter fstream = new FileWriter("possibleRules.txt");
			BufferedWriter out = new BufferedWriter(fstream);
			for(String hash : possibleRules.keySet()){
				if(isValidHash(hash)){
					out.write(hash+" | "+ possibleRules.get(hash)+"\n");
				}
			}
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		// Genetic algorithms start
		for(String hash : possibleRules.keySet()){
			
		}
		
	}

	private boolean isValidHash(String hash) {
		String test = hash;
		for(int legalState : legalStates){
			test = test.replace(legalState+"-", "");
		}
		
		// If empty, only legal states
		if(test.isEmpty()){
			return true;
		}
		
		return false;
	}
	
	
	public static void main(String[] args) {
		new BetterGeneticAlgorithm();
	}
	
	
}
